#include <algorithm>
//#include <functional>
#include <iostream>
#include <vector>
using namespace std;

template<class IteratorTyp, class FunctionClass>
IteratorTyp suche(IteratorTyp pos, IteratorTyp ende, FunctionClass pred)
{
	for(;pos != ende && !pred(*pos); ++pos);
	return pos;
}

class Odd
{
  public:
    bool operator() (int x) const
    { return ((x % 2) != 0); }
};


void main()
{
	const int nele = 5;
	int ia[nele] = {2,4,8,4,5};
	vector<int> iv(ia, ia+nele);

// Funktionsobjekt als Parameter fr den eigenen suche()-Algorithmus
	int *pos = suche(iv.begin(), iv.end(), Odd());
	if (pos != iv.end())
		cout << "in iv gefunden: " << *pos << endl;

// Funktionsobjekt als Parameter fr den STL-Algorithmus find_if()
	pos = find_if(iv.begin(), iv.end(), Odd());
	if (pos != iv.end())
		cout << "in iv gefunden: " << *pos << endl;
}