#include "HalloMFC.h"

CHalloMFCApp halloMFCApp;

BOOL CHalloMFCApp::InitInstance()
{
	m_pMainWnd = new CHalloMFCWnd;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	m_pMainWnd->UpdateWindow();
	
	return TRUE;
}

BEGIN_MESSAGE_MAP (CHalloMFCWnd, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_COMMAND(ID_INFO, Info)
	ON_COMMAND(ID_DATEI_BEENDEN, OnClose)
	ON_COMMAND(ID_MUSIK_ANAUS, MusikAnAus)
	ON_COMMAND(ID_MUSIK_WAHL, MusikWahl)
	ON_UPDATE_COMMAND_UI(ID_MUSIK_ANAUS, UpdateMusikAnAus)
	ON_UPDATE_COMMAND_UI(ID_MUSIK_WAHL, UpdateMusikWahl)
END_MESSAGE_MAP()

CHalloMFCWnd::CHalloMFCWnd()
{
	m_bMusikAnAus = true;

//	LoadFrame(IDR_MAINFRAME);
	CString Titel;
	Titel.LoadString(IDR_MAINFRAME);
	Create(AfxRegisterWndClass(CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW,
		AfxGetApp()->LoadCursor(IDC_CURSOR1),
		(HBRUSH) (COLOR_WINDOW+1),
		AfxGetApp()->LoadIcon(IDR_MAINFRAME)),
		Titel,
		WS_OVERLAPPEDWINDOW,
		CRect(300, 200, 600, 400),
		NULL,
		MAKEINTRESOURCE(IDR_MAINFRAME));
	LoadAccelTable(MAKEINTRESOURCE(IDR_MAINFRAME));

	// Symbolleiste erstellen
	UINT symbole[] = {ID_DATEI_BEENDEN,
					 ID_SEPARATOR,
					 ID_MUSIK_ANAUS,
					 ID_MUSIK_WAHL,
					 ID_SEPARATOR,
					 ID_INFO};
	m_ctrlSmblste.Create(this, WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_FLYBY|CBRS_TOOLTIPS);
	m_ctrlSmblste.LoadBitmap(IDB_SMBLSTE);
	m_ctrlSmblste.SetButtons(symbole, sizeof(symbole)/sizeof(UINT));
	// Symbolleiste verschiebbar machen
	m_ctrlSmblste.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_LEFT|CBRS_ALIGN_RIGHT|CBRS_ALIGN_TOP);
	DockControlBar(&m_ctrlSmblste,AFX_IDW_DOCKBAR_TOP);

	// Statuszeile erstellen
	UINT status[] =  {ID_SEPARATOR,
					 ID_INDICATOR_NUM,
					 ID_INDICATOR_CAPS,
					 ID_INDICATOR_SCRL};
	m_ctrlStatuslste.Create(this);
	m_ctrlStatuslste.SetIndicators(status, sizeof(status)/sizeof(UINT));

	m_ctrlStatuslste.SetPaneInfo(0,0,SBPS_STRETCH,0);
}

int CHalloMFCWnd::OnCreate(LPCREATESTRUCT lpcs)
{
	if (CFrameWnd::OnCreate(lpcs) == -1)
		return -1;
	//Hier wird eine API-Funktion aufgerufen
	PlaySound("chord.wav", NULL, SND_FILENAME | SND_ASYNC);
	return 0;
}

void CHalloMFCWnd::OnPaint()
{
	CPaintDC dc(this);
	CRect rect;

	PlaySound("ding.wav", NULL, SND_FILENAME | SND_ASYNC);
	GetClientRect(&rect);
	dc.DrawText("Hallchen!", -1, &rect, DT_SINGLELINE|DT_CENTER|DT_VCENTER);
}

void CHalloMFCWnd::Info()
{
	CInfo InfoFenster(this);
	InfoFenster.DoModal();
}

void CHalloMFCWnd::MusikAnAus()
{
	if (m_bMusikAnAus)
		m_bMusikAnAus = FALSE;
	else
		m_bMusikAnAus = TRUE;
}

void CHalloMFCWnd::MusikWahl()
{
	MessageBox("Hier knnte eine Auswahl angeboten werden",
		"Whl was", MB_ICONEXCLAMATION|MB_OK);
}

void CHalloMFCWnd::UpdateMusikAnAus(CCmdUI* pCmdUI)
{
	if (m_bMusikAnAus)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CHalloMFCWnd::UpdateMusikWahl(CCmdUI* pCmdUI)
{
	if (m_bMusikAnAus)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}
